<template>
  <v-card>
    <v-card-text>
      <v-stepper v-model="stepActual" class="stepper-1">
        <v-stepper-header>
          <v-stepper-step color="accent" :complete="stepActual > 1" step="1">
            {{ titulo }}
          </v-stepper-step>

          <v-divider />

          <v-stepper-step v-if="stepActual && !isEditar" color="accent" :complete="stepActual > 2" step="2">
            Ingresar Contraseña
          </v-stepper-step>
        </v-stepper-header>

        <v-stepper-content step="1">
          <v-form ref="form">
            <!--Nombre-->
            <v-text-field
              ref="inputNombre"
              v-model="formRegistro.name"
              name="nombre"
              label="Nombre y Apellido *"
              autofocus
              type="text"
              :rules="rules.campo"
              required
              color="accent"
            />
            <!--DNI-->
            <v-text-field
              ref="inputDNI"
              v-model="formRegistro.dni"
              name="DNI"
              label="DNI *"
              type="text"
              :rules="rules.campo"
              required
              color="accent"
            />
            <!--Email-->
            <v-text-field
              ref="inputEmail"
              v-model="formRegistro.email"
              name="email"
              label="Email *"
              type="text"
              :rules="rules.email"
              color="accent"
              required
            />
            <!--Fecha Nacimiento-->
            <v-menu
              ref="menufecha"
              v-model="menufecha"
              :close-on-content-click="false"
            >
              <template #activator="{ on }">
                <v-text-field
                  v-model="fechaNacimiento"
                  label="Fecha de Nacimiento"
                  placeholder="Haga Click Aquí"
                  prepend-icon="fal fa-calendar-minus"
                  readonly
                  color="accent"
                  v-on="on"
                />
              </template>
              <v-date-picker
                ref="picker"
                v-model="formRegistro.fecha_nacimiento"
                locale="es-es"
                :max="new Date().toISOString().substr(0, 10)"
                min="1930-01-01"
                color="accent"
                @change="menufecha=false"
              />
            </v-menu>
            <!--Telefono-->
            <v-text-field
              v-model="formRegistro.telefono"
              label="Teléfono *"
              type="text"
              :rules="rules.campo"
              color="accent"
              required
            />
            <!--Direccion-->
            <v-text-field
              v-model="formRegistro.direccion"
              label="Dirección *"
              type="text"
              :rules="rules.campo"
              color="accent"
              required
            />
            <!--Matricula-->
            <v-text-field
              v-model="formRegistro.matricula"
              label="Matrícula *"
              type="text"
              :rules="rules.campo"
              color="accent"
              required
            />
          </v-form>
          <small>(*) campos requeridos</small>
        </v-stepper-content>
        <v-stepper-content step="2">
          <v-form ref="step" @submit.prevent="validarStep">
            <v-row class="pa-2">
              <v-col>
                <v-text-field
                  v-model="password"
                  :append-icon="showPass.show1 ? 'far fa-eye' : 'far fa-eye-slash'"
                  :rules="[validatePasswordLength]"
                  :type="showPass.show1 ? 'text' : 'password'"
                  name="input-10-1"
                  label="Ingrese contraseña"
                  color="accent"
                  counter
                  @click:append="showPass.show1 = !showPass.show1"
                />
              </v-col>
              <v-col>
                <v-text-field
                  v-model="passwordConfirmation"
                  :append-icon="showPass.show2 ? 'far fa-eye' : 'far fa-eye-slash'"
                  :rules="[validatePasswordConfirmLength,validatePasswordConfirm ]"
                  :type="showPass.show2 ? 'text' : 'password'"
                  name="input-10-2"
                  label="Ingrese la misma contraseña"
                  color="accent"
                  counter
                  class="input-group--focused"
                  @click:append="showPass.show2 = !showPass.show2"
                />
              </v-col>
            </v-row>
          </v-form>
        </v-stepper-content>
      </v-stepper>
    </v-card-text>
    <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
      <template v-if="stepActual === 1">
        <v-btn class="elevation-2 font-weight-light" @click="cerrarDialog()">
          Cerrar
        </v-btn>
        <v-spacer />
        <v-btn v-if="!isEditar" class="elevation-2 font-weight-light" dark color="accent" @click="validarForm">
          Siguiente
        </v-btn>
        <v-btn v-else class="elevation-2 font-weight-light accent" @click="validarForm">
          Modificar
        </v-btn>
      </template>
      <template v-else-if="stepActual === 2 && !isEditar">
        <v-btn
          class="elevation-2 font-weight-light"
          @click="stepActual = 1"
        >
          Volver
        </v-btn>
        <v-spacer />
        <v-btn
          class="elevation-2 font-weight-light"
          style="color: white"
          color="accent"
          @click="validarStep()"
        >
          Finalizar
        </v-btn>
      </template>
    </v-card-actions>
  </v-card>
</template>

<script lang="ts">
import { Component, Prop, Ref, Vue, Watch } from 'vue-property-decorator'
import { Veterinario } from '~/core/models/veterinario'
import { AppStore } from '~/store/AppStore'
import AppToast from '~/core/utils/AppToast'
import { VeterinariosStore } from '~/store/VeterinariosStore'
import { DateHelpers } from '~/core/helpers/DateHelpers'

@Component
export default class formVeterinarios extends Vue {
  @Ref('form') formulario;
  @Ref('picker') picker;
  @Ref('step') step;

  @Prop({ default: null }) veterinario!:Veterinario;

  // Variables
  stepActual:number=1;
  menufecha:boolean = false;
  titulo:string = 'Registrar nuevo Veterinario';

  // Incializacion de atributos del formulario de registro
  formRegistro:Veterinario = {
    name: '',
    tipo: null,
    direccion: null,
    email: '',
    dni: null,
    fecha_nacimiento: '',
    matricula: '',
    telefono: ''
  };

  password='';
  passwordConfirmation='';
  showPass = {
    show1: false,
    show2: false
  };

  // Reglas requeridas al rellenar el formulario de registro
  rules = {
    campo: [
      v => !!v || 'Campo requerido'
    ],
    email: [
      v => !!v || 'Campo requerido',
      v => /.+@.+/.test(v) || 'E-mail inválido'
    ]
  };

  get fechaNacimiento ():string {
    return this.formRegistro.fecha_nacimiento ? DateHelpers.convertHumanFecha(this.formRegistro.fecha_nacimiento) : ''
  }

  @Watch('menufecha')
  onmenufechachange () {
    setTimeout(() => (this.picker.activePicker = 'YEAR'))
  }

  // Validamos las passwords para que sean un poco seguras
  get validatePasswordConfirm () {
    return (this.password === this.passwordConfirmation) ? true : 'Las contraseñas no son iguales'
  }

  get validatePasswordLength () {
    return (this.password.length >= 8) ? true : 'La contraseña debe contener como mínimo 8 caracteres'
  }

  get validatePasswordConfirmLength () {
    return (this.passwordConfirmation.length >= 8) ? true : 'La contraseña debe contener como mínimo 8 caracteres'
  }

  // Mounted es una funcion que se ejecuta antes de renderizar el formulario.
  mounted () {
    console.log('formVeterinarios:', this.isEditar)
    if (this.isEditar) {
      this.cargarFormConUserActual()
    }
  }

  // En caso de que el user actual exista, es porque la operadacion es de editar
  get isEditar ():boolean {
    return !this.veterinario
  }

  // Cargo el formulario con el user ya existente
  private cargarFormConUserActual () {
    Object.assign(
      this.formRegistro,
      this.veterinario
    )
  }

  cerrarDialog () {
    this.$emit('onClose')
  }

  /* Validamos el primer Step del formulario, cuando decimos validar, nos referimos a que todos los campo
     cumplan con las rules definidas para dicho formulario */
  validarForm () {
    // Validamos que el form este completo
    if (this.formulario.validate()) {
      if (this.isEditar) { this.modificar() } else { this.stepActual = 2 }
    } else {
      AppToast.error('Campos inválidos')
    }
  }

  // Validamos el segundo Step, (user y pass)
  validarStep () {
    if (this.step.validate()) {
      this.registrar()
    } else {
      AppToast.error('Campos inválidos')
    }
  }

  private async registrar () {
    AppStore.SHOW_LOADING('Registrando...')
    const nuevo = {
      ...this.formRegistro,
      password: this.password,
      password_confirmation: this.password
    }
    try {
      await VeterinariosStore.registrarVeterinario(nuevo).then((response) => { this.$emit('addedVeterinario', response) })
      AppToast.success('Usuario Registrado')
    } catch (e) {
      this.stepActual = 1
    }
    AppStore.HIDE_LOADING()
  }

  private async modificar () {
    AppStore.SHOW_LOADING('Guardando cambios')
    try {
      await VeterinariosStore.modificarVeterinario(this.formRegistro)
      AppToast.success('Usuario modificado')
    } catch (e) {
    }
    AppStore.HIDE_LOADING()
  }
}
</script>

<style lang="scss">

</style>
